#=======================
# SNA Training
# July 2013
# A.V. Papachristos
#=======================

# ~~~~~~~~~ copyright 2012 ~~~~~~~~~~~~~~~~~~~


#-------------------------------------------
#  DAY 2.  HOMEWORK SOLUTION
#-------------------------------------------

library(igraph)

#1. Read in data
edges<-read.csv('homeworknet.csv', sep=",", header=TRUE)

#2. make it a 'graph' object
net<-graph.data.frame(edges, directed=FALSE) 

#3. plot
plot(net,layout=layout.kamada.kawai, vertex.color="black", vertex.label.color="white")
 
 
#-------------------------------------------
# HOMEWORK SOLUTION ~ ADVANCED EXERCISE
#-------------------------------------------

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
#      Network Attributes
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#

#1. First read in a table of network attributes
attribs<-read.csv("homeworkattributes.csv", as.is=TRUE, header=TRUE)

#take a peak at data
attribs

#remake graph with attribtes attached
net<-graph.data.frame(edges, directed=FALSE, vertices=attribs) 

#2. Now you can plot by different attributes

par(mar=c(2,2,1.5,2))
plot(net, vertex.color=V(net)$gangmember, vertex.label=NA,layout=layout.kamada.kawai)

#you can add a title
title(main="An Example Graph")

#you can add a legend
legend("topleft", legend=c("gang", "non-gang"), col=c("black", "red"), pch=15)


#-------------------------------------------
# OTHER STUFF YOU MIGHT WANT TO KNOW
#------------------------------------------

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#   How to save a network graph
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# This pdf() command STARTS to write  pdf to your WORKING DIRECTORY
pdf("network_graph.pdf")

# THEN you run the plot command

par(mar=c(2,2,1.5,2))
plot(net, vertex.color=V(net)$gangmember, vertex.label=NA,layout=layout.kamada.kawai)
title(main="An Example Graph")

legend("topleft", legend=c("gang", "non-gang"), col=c("black", "red"), pch=15)

# the dev.off() turns OFF the pdf writer...and, if you did it write, it should appear in your WD
dev.off()

 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#   How to save a set of vertex attributes
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

vertex.data <- get.data.frame(net, what="vertices")

#take a look:

vertex.data


#write csv file to your directory

write.table(vertex.data, file="vertex.data.csv", sep=",", col.names=NA)
